' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/01/24 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    '͈
    Public m_ExeRegion As New FvRectangle

    Public m_blnFlag As Boolean = False

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        cmbDirection.Items.Add("")  'Y_DIRECTION
        cmbDirection.Items.Add("")  'X_DIRECTION
        cmbDirection.Items.Add("")    'TOP_DIRECTION
        cmbDirection.Items.Add("")    'DOWN_DIRECTION
        cmbDirection.Items.Add("")    'LEFT_DIRECTION
        cmbDirection.Items.Add("E")    'RIGHT_DIRECTION
        cmbDirection.SelectedIndex = 0

        cmbBfilterDirection.Items.Add("YX_DIRECTION")
        cmbBfilterDirection.Items.Add("XY_DIRECTION")
        cmbBfilterDirection.Items.Add("Y_ONLY_DIRECTION")
        cmbBfilterDirection.Items.Add("X_ONLY_DIRECTION")
        cmbBfilterDirection.SelectedIndex = 0

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        '͈͂̏lݒ(摜̑Sʂɐݒj
        m_ExeRegion.xs = -1
        m_ExeRegion.xe = -1
        m_ExeRegion.ys = -1
        m_ExeRegion.ye = -1

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImageOrg.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImageOrg.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()
        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImageOrg.GetOcx())

        '2l\
        AxFvxChangeImage1.FixedLevel(AxFvxImageOrg.GetOcx(), AxFvxImageOrgBin.GetOcx(), 128)
        AxFvxDisplayEx1.DrawImage(AxFvxImageOrgBin.GetOcx())

        AxFvxDisplayEx1.ClearOverlay()
        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
        AxFvxDisplayEx1.DrawData(0, m_ExeRegion)

        m_blnFlag = True

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        If Me.WindowState = 0 Or Me.WindowState = 2 Then
            Dim newSize As New Size
            newSize.Width = Me.Width - AxFvxDisplayEx1.Left - 20
            newSize.Height = Me.Height - AxFvxDisplayEx1.Top - 55
            AxFvxDisplayEx1.Size = newSize
        End If

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    '͈͂̐ݒ
    Private Sub btnExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_ExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImageOrgBin.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_ExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_ExeRegion.xe < m_ExeRegion.xs Then
                dblTemp = m_ExeRegion.xs
                m_ExeRegion.xs = m_ExeRegion.xe
                m_ExeRegion.xe = dblTemp
            End If
            If m_ExeRegion.ye < m_ExeRegion.ys Then
                dblTemp = m_ExeRegion.ys
                m_ExeRegion.ys = m_ExeRegion.ye
                m_ExeRegion.ye = dblTemp
            End If

            '͈͂Kp
            AxFvxBinFilter1.SetInspectArea(m_ExeRegion)
            AxFvxDisplayEx1.ClearOverlay()
            AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
            AxFvxDisplayEx1.DrawData(0, m_ExeRegion)
        End If

    End Sub

    'J摜捞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImageOrg.GetOcx())

        '捞
        AxFvxVideo1.GrabSync(AxFvxImageOrg.GetOcx())

        '2l\
        Binarize()

    End Sub

    '摜Ǎ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        Dim intErr As Integer

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then
            'FileAccessR|[lgpāA
            't@CImageɉ摜ǂݍ݂܂
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImageTemp.GetOcx())
            Catch ex As System.Exception
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImageTemp.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray _
                Or AxFvxImageTemp.ImageWidth <> 512 Or AxFvxImageTemp.ImageHeight <> 480 Then
                MsgBox("512*480 1/8bitOC̉摜ł͂܂", , "error")

                AxFvxImageTemp.BitPerPixel = 8
                AxFvxImageTemp.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImageTemp.ImageWidth = 512
                AxFvxImageTemp.ImageHeight = 480
            End If

            '2lZW
            If AxFvxImageTemp.BitPerPixel = 1 Then
                AxFvxImageOrg.ClearImage()
                AxFvxImageTemp.CopyTo(AxFvxImageOrgBin.GetOcx())
                AxFvxDisplayEx1.DrawImage(AxFvxImageOrgBin.GetOcx())
            ElseIf AxFvxImageTemp.BitPerPixel = 8 Then
                AxFvxImageTemp.CopyTo(AxFvxImageOrg.GetOcx())
                Binarize()
            Else
                MsgBox("1bit/8bitȊObmpł", , "ǍG[")
            End If
        End If

    End Sub

    '2l摜ۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImageOrgBin.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    '2l臒lύX
    Private Sub txtBinLevel_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtBinLevel.TextChanged

        Binarize()

    End Sub

    '2l
    Private Sub Binarize()

        Dim intBinLevel As Integer

        If Integer.TryParse(txtBinLevel.Text, intBinLevel) = False Then intBinLevel = 0

        If intBinLevel < 0 Then intBinLevel = 0
        If intBinLevel > 255 Then intBinLevel = 255

        If m_blnFlag = True Then
            AxFvxChangeImage1.FixedLevel(AxFvxImageOrg.GetOcx(), AxFvxImageOrgBin.GetOcx(), intBinLevel)
            AxFvxDisplayEx1.DrawImage(AxFvxImageOrgBin.GetOcx())
        End If

    End Sub

    ' -----------------------------------------------------------------------------
    '  tB^
    ' -----------------------------------------------------------------------------

    'k
    Private Sub btnContrct_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnContrct.Click

        '摜̈ꕔ̏ꍇɁAȊǑ摜ۑ悤ɂ邽߂ɃRs[܂
        AxFvxImageOrgBin.CopyTo(AxFvxImageDstBin.GetOcx())

        'tB^s
        AxFvxBinFilter1.Contrct(AxFvxImageOrgBin.GetOcx(), AxFvxImageDstBin.GetOcx())

        'ωɑĕʂ̏ł悤ɁÃC[WɃRs[Ă܂
        'ÃRs[sƉ摜̗L͈͂ZbgĂ܂܂
        AxFvxImageDstBin.CopyTo(AxFvxImageOrgBin.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImageDstBin.GetOcx())

    End Sub

    '4ߖTk
    Private Sub btnContrct4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnContrct4.Click

        AxFvxImageOrgBin.CopyTo(AxFvxImageDstBin.GetOcx())
        AxFvxBinFilter1.Contrct4(AxFvxImageOrgBin.GetOcx(), AxFvxImageDstBin.GetOcx())
        AxFvxImageDstBin.CopyTo(AxFvxImageOrgBin.GetOcx())
        AxFvxDisplayEx1.DrawImage(AxFvxImageDstBin.GetOcx())

    End Sub

    'c
    Private Sub btnExpand_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExpand.Click

        AxFvxImageOrgBin.CopyTo(AxFvxImageDstBin.GetOcx())
        AxFvxBinFilter1.Expand(AxFvxImageOrgBin.GetOcx(), AxFvxImageDstBin.GetOcx())
        AxFvxImageDstBin.CopyTo(AxFvxImageOrgBin.GetOcx())
        AxFvxDisplayEx1.DrawImage(AxFvxImageDstBin.GetOcx())

    End Sub

    '4ߖTc
    Private Sub btnExpand4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExpand4.Click

        AxFvxImageOrgBin.CopyTo(AxFvxImageDstBin.GetOcx())
        AxFvxBinFilter1.Expand4(AxFvxImageOrgBin.GetOcx(), AxFvxImageDstBin.GetOcx())
        AxFvxImageDstBin.CopyTo(AxFvxImageOrgBin.GetOcx())
        AxFvxDisplayEx1.DrawImage(AxFvxImageDstBin.GetOcx())

    End Sub

    ']
    Private Sub btnNot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNot.Click

        AxFvxImageOrgBin.CopyTo(AxFvxImageDstBin.GetOcx())
        AxFvxBinFilter1.[Not](AxFvxImageOrgBin.GetOcx(), AxFvxImageDstBin.GetOcx())
        AxFvxImageDstBin.CopyTo(AxFvxImageOrgBin.GetOcx())
        AxFvxDisplayEx1.DrawImage(AxFvxImageDstBin.GetOcx())

    End Sub

    'Ǘ_
    Private Sub btnSolodel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSolodel.Click

        AxFvxImageOrgBin.CopyTo(AxFvxImageDstBin.GetOcx())
        AxFvxBinFilter1.Solodel(AxFvxImageOrgBin.GetOcx(), AxFvxImageDstBin.GetOcx())
        AxFvxImageDstBin.CopyTo(AxFvxImageOrgBin.GetOcx())
        AxFvxDisplayEx1.DrawImage(AxFvxImageDstBin.GetOcx())

    End Sub

    'wtߖTc
    Private Sub btnExpandDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExpandDir.Click

        AxFvxImageOrgBin.CopyTo(AxFvxImageDstBin.GetOcx())
        AxFvxBinFilter1.ContrctDir(AxFvxImageOrgBin.GetOcx(), AxFvxImageDstBin.GetOcx(), cmbDirection.SelectedIndex)
        AxFvxImageDstBin.CopyTo(AxFvxImageOrgBin.GetOcx())
        AxFvxDisplayEx1.DrawImage(AxFvxImageDstBin.GetOcx())

    End Sub

    'wtߖTk
    Private Sub btnContrctDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnContrctDir.Click

        AxFvxImageOrgBin.CopyTo(AxFvxImageDstBin.GetOcx())
        AxFvxBinFilter1.ExpandDir(AxFvxImageOrgBin.GetOcx(), AxFvxImageDstBin.GetOcx(), cmbDirection.SelectedIndex)
        AxFvxImageDstBin.CopyTo(AxFvxImageOrgBin.GetOcx())
        AxFvxDisplayEx1.DrawImage(AxFvxImageDstBin.GetOcx())

    End Sub

    'mCY
    Private Sub btnBfilter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBfilter.Click

        Dim intSx As Integer
        Dim intSy As Integer

        If Integer.TryParse(txtHPix.Text, intSx) = False Or intSx < 1 Or intSx > 50 Then
            MsgBox("f 1`50 ͈̔͂œ͂Ă", , "p[^G[")
            Exit Sub
        End If

        If Integer.TryParse(txtVPix.Text, intSy) = False Or intSy < 1 Or intSy > 50 Then
            MsgBox("f 1`50 ͈̔͂œ͂Ă", , "p[^G[")
            Exit Sub
        End If

        AxFvxImageOrgBin.CopyTo(AxFvxImageDstBin.GetOcx())
        AxFvxBinFilter1.Bfilter(AxFvxImageOrgBin.GetOcx(), AxFvxImageDstBin.GetOcx(), intSx, intSy, cmbBfilterDirection.SelectedIndex)
        AxFvxImageDstBin.CopyTo(AxFvxImageOrgBin.GetOcx())
        AxFvxDisplayEx1.DrawImage(AxFvxImageDstBin.GetOcx())

    End Sub

    Private Sub txtBinLevel_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtVPix.KeyPress, txtHPix.KeyPress, txtBinLevel.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub
End Class
